; difference: text is aligned on a byte the old way, word the new way
        page  58,132
        title 'findint - microsoft c routines to find rexx interrupt'
        .MODEL SMALL
        .DATA
        extrn    __psp:word
        .CODE
        include findrexx.asm
        public  _findints, _findintm, _findintl

; assembler routine for microsoft c to find rexx interrupt
;  findints - coded for small model
;  findintm - coded for medium model
;  findintl - coded for large model
;
; int findintX (statusp)     (where X is s, m, or l)
; int *statusp;
;
; interrupt_number = findintX(&interrupt_status)
;
; interrupt_status = 0 rexx interrupt handler loaded
;                    1 RXINT setting invalid (interrupt_number not valid)
;                    2 REXX interrupt vector in use by some other program
;                    3 REXX interrupt vector not in use


_findints proc   near
         push    bp
         mov     bp,sp
; at this point, [bp+2] has 2 byte return offset
;                [bp+4] has 2 byte offset of caller's variable
         mov     es,__psp      ; findrexx expects psp address in es
         call    findrexx      ; findrexx yields ah=int number, al=int status
         mov     dx,ax
         mov     dh,0          ; get interrupt status into dx
         mov     bx,[bp+4]     ; get offset of caller's variable into bx
         mov     word ptr [bx],dx  ; put interrupt status into callers variable
         mov     al,ah
         mov     ah,0          ; get interrupt number into ax
         pop     bp
         ret
_findints endp

_findintm proc    far
         push    bp
         mov     bp,sp
; at this point, [bp+2] has 4 byte return address
;                [bp+6] has 2 byte offset of caller's variable
         mov     es,__psp      ; findrexx expects psp address in es
         call    findrexx      ; findrexx yields ah=int number, al=int status
         mov     dx,ax
         mov     dh,0          ; get interrupt status into dx
         mov     bx,[bp+6]     ; get offset of caller's variable into bx
         mov     word ptr [bx],dx  ; put interrupt status into callers variable
         mov     al,ah
         mov     ah,0          ; get interrupt number into ax
         pop     bp
         ret
_findintm endp

_findintl proc    far
         push    bp
         mov     bp,sp
; at this point, [bp+2] has 4 byte return address
;                [bp+6] has 4 byte address of caller's variable
         mov     es,__psp      ; findrexx expects psp address in es
         call    findrexx      ; findrexx yields ah=int number, al=int status
         mov     dx,ax
         mov     dh,0          ; get interrupt status into dx
         les     bx,[bp+6]     ; get address of callers variable into es:bx
         mov     es:[bx],dx    ; put interrupt status into callers variable
         mov     al,ah
         mov     ah,0          ; get interrupt number into ax
         pop     bp
         ret
_findintl endp
         end
